<template>
  <ui-page :has-sidebar="!!sidebarNavItems">
    <template #header>
      <ui-navbar ref="navbar" :navbar-items="navbarItems" sticky>
        <template #brand>
          <div class="brand">
            <router-link
              class="title rounded text-xl font-bold tracking-tight text-violet-700 outline-none hover:text-violet-900 focus:ring-2 focus:ring-violet-700 lg:text-2xl xl:text-4xl"
              to="/"
              >DSDCare UI</router-link
            >
            <span class="ml-2 text-gray-600">v{{ libVersion }}</span>
          </div>
        </template>
      </ui-navbar>
    </template>
    <template #sidebar>
      <ui-sidebar-nav
        v-if="sidebarNavItems"
        title="Table of contents"
        :items="sidebarNavItems"
        :has-ordered-items="sidebarHasOrderedItems"
      />
    </template>

    <router-view v-slot="{ Component }">
      <component :is="Component" ref="currentPage" />
    </router-view>
  </ui-page>
</template>

<script lang="ts" setup>
import { computed, provide, ref } from 'vue'
import { RouterView, useRouter } from 'vue-router'
import { useElementSize } from '@vueuse/core'
import { SidebarNavItemData } from './propInterfaces'

const libVersion = __LIB_VERSION__

const currentPage = ref()

const navbarItems = computed(() => {
  return useRouter()
    .getRoutes()
    .map((route) => ({
      to: route.path,
      order: 0, // usually overridden by route.meta.order
      label: route?.name?.toString() ?? '', // overridden by route.meta.label if set
      hidden: false, // can be overridden by route.meta.hidden
      ...route.meta,
    }))
    .filter((route) => !route.hidden)
    .sort((a, b) => (a.order >= b.order ? 1 : -1))
})

const sidebarNavItems = computed(
  () =>
    (currentPage.value?.frontmatter?.sidebarNavItems as
      | SidebarNavItemData[]
      | undefined) ?? false,
)

const sidebarHasOrderedItems = computed(
  () =>
    (currentPage.value?.frontmatter?.sidebarHasOrderedItems as
      | boolean
      | undefined) ?? true,
)

const navbar = ref(null)
const { height: navbarHeight } = useElementSize(navbar)

provide(
  'navbarHeight',
  computed(() => Math.floor(navbarHeight.value)),
)
</script>

<style>
html {
  scroll-behavior: smooth;
}
</style>
